export interface Column {
  key: string;
  name: string;
}

export class ComponentWithTable {

  private _hiddenColumns: Column[] = [];
  set hiddenColumns(value: Column[]) {
    this._hiddenColumns = value;
    localStorage.setItem("hiddenColumns", JSON.stringify(value));
  }

  get hiddenColumns(): Column[] {
    return this._hiddenColumns;
  }

  private name: string = "";
  public columns: Column[] = [];

  constructor(
    name: string,
    columns: string[]
  ) {
    this.name = name;
    this.columns = columns.map(column => {
      return { key: this.getKey(column), name: column };
    });
    this._hiddenColumns = JSON.parse(localStorage.getItem("hiddenColumns") ?? "");
  }

  private getKey(column: string): string {
    return `${this.name}_${column}`;
  }

  public isColumnVisible(column: string): boolean {
    return !this._hiddenColumns.map(column => column.key).includes(this.getKey(column));
  }
}
